#include "testlib.h"
#include <iostream>
#include <unordered_set>
#include <cassert>

using namespace std;

struct edge{
    int v, w; char c;
    edge(){}
    edge(int v, int w, char c) : v(v), w(w), c(c) {}
};

int const N = 100000;
set <pair <int, int>> wb, wr;

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = N;
    int red = atoi(argv[2]);
    int black = atoi(argv[3]);
    int qs = atoi(argv[4]);
    int t = atoi(argv[5]);

    vector <edge> all;

    int lftr = rnd.next(N - qs + 1);
    int lftb = rnd.next(N - qs - lftr + 1);
    int r = rnd.next(red - lftr, red);
    int b = rnd.next(black - lftb, black);

    for (int i = 0; i < red; i++) {
        int v = rnd.next(n), w = v;
        while (v == w || wr.count({v, w}) || wr.count({w, v})) {
            w = rnd.next(n);
        }
        wr.insert({v, w});
        all.emplace_back(w, v, 'T');
    }
    cout << n << ' ' << b << ' ' << r << '\n';

    for (int i = 0; i < black; i++) {
        int a = rnd.wnext(n, t), b = a;
        while (b == a || wb.count({a, b}) || wb.count({b, a})) {
            b = rnd.next(n);
        }
        wb.insert({a, b});
        all.emplace_back(a, b, 'F');
    }
    for (int i = 0; i < b; i++) {
        cout << all.back().v + 1 << ' ' << all.back().w + 1 << '\n';
        all.pop_back();
    }

    for (int i = 0; i < r; i++) {
        cout << all.back().v+ 1  << ' ' << all.back().w + 1 << '\n';
        all.pop_back();
    }
    shuffle(all.begin(), all.end());
    assert(qs + all.size() <= N);
    cout << qs + all.size() << '\n';
    vector <int> type;
    for (int i = 0; i < qs; i++) type.push_back(1);
    for (int i = 0; i < all.size(); i++) type.push_back(0);
    shuffle(type.begin(), type.end());
    for (int i : type) {
        if (i) {
            cout << '?' << ' ' << rnd.wnext(n, t) + 1 << '\n';
        } else {
            int cnt = all.size() - 1;
            if (rnd.next(2) == 1) swap(all[cnt].v, all[cnt].w);
            cout << all[cnt].c << ' ' << all[cnt].v + 1 << ' ' << all[cnt].w + 1 << '\n';
            all.pop_back();
        }
    }
    return 0;
}