#include "testlib.h"
#include <set>

using namespace std;

int const N = 100000;

set <pair <int, int>> t, f;

void checkEdge(int n, char c) {
    int v = inf.readInt(1, n, "v");
    inf.readSpace();
    int w = inf.readInt(1, n, "w");
    ensuref(v != w, "loop");
    if (v > w) swap(v, w);
    string req = "edge second time" + to_string(v) + ' ' + to_string(w) + ' ' + c;

    if (c == 'F') {
        ensuref(!f.count({v, w}), req.c_str());
        f.insert({v, w});
    } else {

        ensuref(!t.count({v, w}), req.c_str());
        t.insert({v, w});

    }
    inf.readEoln();

}

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, N, "n");
    inf.readSpace();
    int m = inf.readInt(0, N, "m");
    inf.readSpace();
    int k = inf.readInt(0, N, "k");
    inf.readEoln();
    for (int i = 0; i < m; i++) {
        checkEdge(n, 'F');
    }
    for (int i = 0; i < k; i++) {
        checkEdge(n, 'T');
    }
    int q;
    q = inf.readInt(0, N, "q");
    inf.readEoln();
    for (int i = 0; i < q; i++) {
        char c = inf.readChar();
        inf.readSpace();
        ensuref(c == 'T' || c == 'F' || c == '?', "wrong query " + c);
        if (c != '?') {
            checkEdge(n, c);
        } else {
            int v = inf.readInt(1, n, "v");
            inf.readEoln();
        }
    }
    inf.readEof();
    return 0;
}
