// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 100100;
 
std::set<int> s[N];
int p[N], sz[N];
std::vector<int> g[N];
int ans[N];
 
void dsuInit() {
    for (int i = 0; i < N; ++i) {
        p[i] = i;
        sz[i] = 1;
        s[i].insert(i);
    }
}
 
int dsuGet(int v) {
    if (v == p[v]) {
        return v;
    }
    return p[v] = dsuGet(p[v]);
}
 
void dsuUnite(int a, int b) {
    a = dsuGet(a);
    b = dsuGet(b);
 
    if (a == b) {
        return;
    }
 
    if (sz[a] > sz[b]) {
        std::swap(a, b);
    }
 
    for (auto i : s[a]) {
        for (auto to : g[i]) {
            if (dsuGet(to) == b) {
                ++ans[i];
                ++ans[to];
            }
        }
 
        s[b].insert(i);
    }
 
    p[a] = b;
    sz[b] += sz[a];
}
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    int n, m, k;
    scanf("%d%d%dd", &n, &m, &k);
 
    while (m--) {
        int from, to;
        scanf("%d%d", &from, &to);
 
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
 
    dsuInit();
 
    while (k--) {
        int from, to;
        scanf("%d%d", &from, &to);
 
        dsuUnite(from - 1, to - 1);
    }
 
    int q;
    scanf("%d", &q);
 
    while (q--) {
        char type;
        scanf("\n%c", &type);
 
        if (type == 'T') {
            int from, to;
            scanf("%d%d", &from, &to);
 
            dsuUnite(from - 1, to - 1);
        } else if (type == 'F') {
            int from, to;
            scanf("%d%d", &from, &to);
 
            g[from - 1].push_back(to - 1);
            g[to - 1].push_back(from - 1);
 
            if (dsuGet(from - 1) == dsuGet(to - 1)) {
                ++ans[from - 1];
                ++ans[to - 1];
            }
        } else {
            int v;
            scanf("%d", &v);
 
            printf("%d\n", ans[v - 1]);
        }
    }
 
    return 0;
}
