#include <bits/stdc++.h>

using namespace std;

int main() {
#ifdef GOLIKOV
  std::freopen("in", "rt", stdin);
#endif
  int n, m, k;
  cin >> n >> k >> m;
  vector<int> ans(n, 0);
  vector<int> color(n);
  vector<vector<int>> component(n);
  for (int i = 0; i < n; i++) {
    color[i] = i;
    component[i].push_back(i);
  }
  vector<vector<int>> lazy(n);
  auto addEdge = [&](int x, int y) {
    if (color[x] == color[y]) {
      return;
    }
    if (component[color[x]].size() < component[color[y]].size()) {
      swap(x, y);
    }
    int from = color[y];
    for (int v : component[from]) {
      for (int to : lazy[v]) {
        if (color[to] == color[x]) {
          ans[v]++;
          ans[to]++;
        }
      }
    }
    while (!component[from].empty()) {
      int v = component[from].back();
      component[from].pop_back();
      color[v] = color[x];
      component[color[x]].push_back(v);
    }
  };
  auto makeFriends = [&](int x, int y) {
    if (color[x] == color[y]) {
      ans[x]++;
      ans[y]++;
      return;
    }
    lazy[x].push_back(y);
    lazy[y].push_back(x);
  };
  vector<pair<int,int>> friends;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    friends.emplace_back(x - 1, y - 1);
  }
  for (int i = 0; i < m; i++) {
    int x, y;
    cin >> x >> y;
    addEdge(x - 1, y - 1);
  }
  for (auto &e : friends) {
    makeFriends(e.first, e.second);
  }
  int q;
  cin >> q;
  while (q--) {
    char type;
    cin >> type;
    if (type == 'T') {
      int x, y;
      cin >> x >> y;
      addEdge(x - 1, y - 1);
    } else if (type == 'F') {
      int x, y;
      cin >> x >> y;
      makeFriends(x - 1, y - 1);
    } else {
      int x;
      cin >> x;
      cout << ans[x - 1] << '\n';
    }
  }
}
