#include <iostream>
#include <vector>

using namespace std;

vector<pair<unsigned int, unsigned int>> collect(vector<unsigned int> const &a,
                                                 unsigned int l, unsigned int r, unsigned int m) {
    vector<pair<unsigned int, unsigned int>> res(m, {0, 0});
    for (unsigned int mask = 1u; mask < (1u << (r - l)); mask++) {
        vector<int> taken;
        for (unsigned int bit = 0; bit < r - l; bit++) {
            if ((mask >> bit) & 1u) {
                taken.push_back(a[l + bit]);
            }
        }
        unsigned int cnt = taken.size();
        for (unsigned int positive = 0; positive < (1u << cnt); positive++) {
            long long sum = 0;
            for (unsigned int bit = 0; bit < cnt; bit++) {
                if ((positive >> bit) & 1u) {
                    sum += taken[bit];
                } else {
                    sum -= taken[bit];
                }
            }
            sum = ((sum % m) + m) % m;

            res[sum % m] = {mask, positive};
        }
    }
    return res;
}

pair<vector<unsigned int>, vector<unsigned int>> output(vector<unsigned int> const &a, unsigned int mask, unsigned int positive) {
    vector<int> taken;
    for (unsigned int bit = 0; bit < a.size(); bit++) {
        if ((mask >> bit) & 1u) {
            taken.push_back(bit + 1);
        }
    }
    vector<unsigned int> res1, res2;
    for (unsigned int bit = 0; bit < taken.size(); bit++) {
        if ((positive >> bit) & 1u) {
            res1.push_back(taken[bit]);
        } else {
            res2.push_back(taken[bit]);
        }
    }
    return {res1, res2};
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    cin >> n >> m;
    vector<unsigned int> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    auto l = collect(a, 0, n / 2, m), r = collect(a, n / 2, n, m);
    auto print1 = [](vector<unsigned int> const &w) {
        cout << w.size() << '\n';
        for (unsigned int x : w) {
            cout << x << ' ';
        }
        cout << '\n';
    };
    if (l[0].first != 0) {
        auto v = output(a, l[0].first, l[0].second);
        print1(v.first);
        print1(v.second);
        return 0;
    } else if (r[0].first != 0) {
        auto v = output(a, r[0].first << (n / 2), r[0].second);
        print1(v.first);
        print1(v.second);
        return 0;
    } else {
        for (unsigned int i = 1; i < m; i++) {
            if (l[i].first != 0 && r[m - i].first != 0) {
                auto v1 = output(a, l[i].first, l[i].second);
                auto v2 = output(a, r[m - i].first << (n / 2), r[m - i].second);
                auto print2 = [](vector<unsigned int> const &w1, vector<unsigned int> const &w2) {
                    cout << w1.size() + w2.size() << '\n';
                    for (int x : w1) {
                        cout << x << ' ';
                    }
                    for (int x : w2) {
                        cout << x << ' ';
                    }
                    cout << '\n';
                };
                print2(v1.first, v2.first);
                print2(v1.second, v2.second);
                return 0;
            }
        }
    }

    cout << "-1\n";

}
