#include "testlib.h"
#include <iostream>
#include <string>
#include <vector>
#include <assert.h>
#include <bitset>

#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()

using namespace std;

string shuffleString(string s, vector<int> p) {
    int n = sz(s);
    string res(n, ' ');
    rep(i, 0, n) {
        res[p[i]] = s[i];
    }
    return res;
}

void shuffleTest(string &s, vector<string> &tests) {
    int n = sz(s);
    vector<int> p(n);
    rep(i, 0, n) {
        p[i] = i;
    }
    shuffle(p.begin(), p.end());
    s = shuffleString(s, p);
    rep(i, 0, sz(tests)) {
        tests[i] = shuffleString(tests[i], p);
    }
    shuffle(tests.begin(), tests.end());
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int k = atoi(argv[2]);
    int m = atoi(argv[3]);

    string answer = "";
    rep(i, 0, n) {
        answer += char('A' + rnd.next(0, 3));
    }

    string test = answer;
    rep(i, 0, k) {
        test[i] = (test[i] < 'D' ? test[i] + 1 : 'A');
    }

    vector<string> tests(m, test);

    shuffleTest(answer, tests);

    cout << n << "\n";
    cout << answer << "\n";
    cout << m << "\n";
    for (auto it : tests) {
        cout << it << "\n";
    }
    return 0;
}