// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>
#include "testlib.h"

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main(int argc, char** argv) {
    // code here
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<tuple<int, int, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        int a = inf.readInt();
        int b = inf.readInt();
        int c = inf.readInt();

        arr[i] = make_tuple(min({a,b,c}), a+b+c - min({a,b,c}) - max({a,b,c}), max({a,b,c}));
    }

    sort(ALL(arr));
    
    vector<int> sol = ouf.readInts(n, 1, n);

    vector<char> used(n + 1);
    for (int x: sol)
        if (used[x]++)
            quitf(_wa, "the answer is not a permutation");

    vector<tuple<int,int,int>> pr(n);
    for (int i = 0; i < n; ++i) {
        int a = sol[i];
        int b = sol[(i + 1) % n];
        int c = sol[(i + 2) % n];

        pr[i] = make_tuple(min({a,b,c}), a+b+c - min({a,b,c}) - max({a,b,c}), max({a,b,c}));
    }

    sort(ALL(pr));

    if (arr == pr)
        quitf(_ok, "");
    else
        quitf(_wa, "the set of triples differs");
    
    return 0;
}
