// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n = input<int>();

    if (n <= 4) {
        for (int i = 1; i <= n; ++i)
            cout << i << " ";
        cout << "\n";
        return 0;
    }

    vector<array<int, 3>> in(n);
    map<pair<int, int>, vector<int>> lists; 
    for (int i = 0; i < n; ++i) {
        in[i][0] = input<int>() - 1;
        in[i][1] = input<int>() - 1;
        in[i][2] = input<int>() - 1;

        sort(ALL(in[i]));
        lists[make_pair(in[i][0], in[i][1])].push_back(in[i][2]);
        lists[make_pair(in[i][0], in[i][2])].push_back(in[i][1]);
        lists[make_pair(in[i][1], in[i][2])].push_back(in[i][0]);
    }

    for (int st = 0; st < 3; ++st) {
        vector<int> cur;
        for (int i = 0; i < 3; ++i)
            cur.push_back(in[0][(st + i) % 3]);

        vector<char> used(n, false);
        used[cur[0]] = 1;
        used[cur[1]] = 1;
        used[cur[2]] = 1;
        
        while (SZ(cur) < n) {
            int a = cur.back();
            int b = cur[SZ(cur) - 2];

            bool ok = false;
            for (int x: lists[make_pair(min(a,b), max(a,b))])
                if (x != cur[SZ(cur) - 3]) {
                    cur.push_back(x);

                    if (used[x]++)
                        assert(false);
                    
                    ok = true;
                    break;
                }

            if (not ok)
                break;
        }

        if (SZ(cur) == n) {
            for (int elem: cur)
                cout << 1 + elem << " ";

            cout << "\n";
            return 0;
        }   
    }

    assert(false);
    
    return 0;
}
