import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.FileNotFoundException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class superpermutations_av {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        FastScanner in = new FastScanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Superpermutations solver = new Superpermutations();
        solver.solve(1, in, out);
        out.close();
    }

    static class Superpermutations {
        final int MOD = 1_000_000_007;

        public void solve(int testNumber, FastScanner in, PrintWriter out) {
            int n = in.nextInt();
            int[] a = in.nextIntArray(n);
            int[] pos = new int[n];
            for (int i = 0; i < n; i++) {
                pos[a[i] - 1] = i;
            }
            BITSum tree = new BITSum(n);
            int[] relativePos = new int[n];
            for (int i = 0; i < n; i++) {
                tree.add(i, 1);
            }
            for (int i = n - 1; i >= 0; i--) {
                tree.add(pos[i], -1);
                if (i == n - 1) {
                    relativePos[i] = pos[i];
                    continue;
                }
                if (pos[i] > pos[i + 1]) {
                    relativePos[i] = tree.sum(pos[i + 1], pos[i]);
                } else {
                    relativePos[i] = tree.sum(pos[i + 1], n - 1) + tree.sum(0, pos[i]);
                }
            }

            out.println(getPos(relativePos, n)[1] + 1);
        }

        int[] getPos(int[] relativePos, int curLength) {
            if (curLength == 1) {
                return new int[]{0, 0};
            }
            int[] ret = getPos(relativePos, curLength - 1);
            int shift = curLength - 1 - relativePos[curLength - 1];

            int[] result = new int[2];
            result[0] = (int) (((long) ret[0] * curLength + shift) % MOD);
            result[1] = (int) ((ret[1] + (long) ret[0] * curLength + shift) % MOD);
            return result;
        }

    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public FastScanner(String fileName) {
            try {
                br = new BufferedReader(new FileReader(fileName));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public String next() {
            while (st == null || !st.hasMoreElements()) {
                String line = null;
                try {
                    line = br.readLine();
                } catch (IOException e) {
                }
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public int[] nextIntArray(int n) {
            int[] ret = new int[n];
            for (int i = 0; i < n; i++) {
                ret[i] = nextInt();
            }
            return ret;
        }

    }

    static class BITSum {
        int[] tree;

        public BITSum(int size) {
            tree = new int[size];
        }

        public BITSum(int[] a) {
            tree = a.clone();
            for (int i = 1; i < tree.length; i++) {
                tree[i] += tree[i - 1];
            }
            for (int i = tree.length - 1; i >= 0; i--) {
                int prev = (i & (i + 1)) - 1;
                if (prev >= 0) {
                    tree[i] -= tree[prev];
                }
            }
        }

        public int sum(int pos) {
            int result = 0;
            while (pos >= 0) {
                result += tree[pos];
                pos = (pos & (pos + 1)) - 1;
            }
            return result;
        }

        public int sum(int l, int r) {
            int result = sum(r);
            if (l - 1 >= 0) {
                result -= sum(l - 1);
            }
            return result;
        }

        public void add(int pos, int val) {
            while (pos < tree.length) {
                tree[pos] += val;
                pos |= pos + 1;
            }
        }

    }
}

