#include <bits/stdc++.h>

using namespace std;

struct DSU {
    vector<int> p;
    vector<int> r;

    DSU(int n) : p(n), r(n, 1) {
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
    }

    int get(int x) {
        if (p[x] != x) {
            p[x] = get(p[x]);
        }
        return p[x];
    }

    void unite(int x, int y) {
        x = get(x);
        y = get(y);
        if (r[x] < r[y]) {
            p[x] = y;
            r[y] += r[x];
        } else {
            p[y] = x;
            r[x] += r[y];
        }
    }
};

int stupid(vector<int> a) {
    int ans = 0;
    int x = a.size();
    for (int i = 0; i < x; i++) {
        bool good = true;
        for (int j = 0; j < x && good; ) {
            int n = a[(i + j) % x];
            if (j + 1 + 2 * (n - 1) > x) {
                good = false;
                break;
            }
            DSU dsu(n);
            for (int k = j + 1; k < j + 1 + 2 * (n - 1); k += 2) {
                int u = a[(i + k + 0) % x] - 1;
                int v = a[(i + k + 1) % x] - 1;
                if (u < 0 || u >= n || v < 0 || v >= n || dsu.get(u) == dsu.get(v)) {
                    good = false;
                    break;
                }
                dsu.unite(u, v);
            }
            j += 1 + 2 * (n - 1);
        }
        if (good) {
            ans++;
        }
    }
    return ans;
}

int main() {
    int x;
    cin >> x;
    vector<int> a(x);
    for (int i = 0; i < x; i++) {
        cin >> a[i];
    }

    cout << stupid(a);

    return 0;
}

                    