// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	int SQRT = max(1, (int) sqrt(n));
	vector<int> arr;
	map<int, int> inds;
	auto get_ind = [&](int v) {
		if (!inds.count(v)) {
			int tmp = szof(inds);
			inds[v] = tmp;
		}
		return inds[v];
	};
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	vector<tuple<int, int, int>> reqs;

	vector<bool> can_start(n, false);

	for (int i = 0; i < n; ++i) {
		if (i + 1 + arr[i] * 2 <= n) {
			reqs.push_back({i + 1, i + 1 + arr[i] * 2, i});
		}
	}

	vector<int> dsu(n);
	iota(dsu.begin(), dsu.end(), 0);
	vector<int> sz(n);
	int dsu_ok = 1;
	vector<pair<int*, int>> changes;

	auto get_root = [&](int v) {
		while (dsu[v] != v) {
			v = dsu[v];
		}
		return v;
	};

	auto add_edge = [&](int a, int b) {
		if (!dsu_ok) {
			return;
		}
		int ra = get_root(a);
		int rb = get_root(b);
		if (ra == rb) {
			changes.push_back({&dsu_ok, dsu_ok});
			dsu_ok = 0;
			return;
		}
		if (sz[ra] > sz[rb]) {
			swap(ra, rb);
		}
		changes.push_back({&dsu[ra], dsu[ra]});
		dsu[ra] = rb;
		if (sz[ra] == sz[rb]) {
			changes.push_back({&sz[rb], sz[rb]});
			++sz[rb];
		}
	};

	for (int shift = 0; shift <= 1; ++shift) {
		vector<vector<pair<pii, int>>> reqs_here((n + SQRT - 1) / SQRT);
		vector<pii> edges;
		for (int i = shift; i + 2 <= n; i += 2) {
			edges.push_back({get_ind(arr[i]), get_ind(arr[i + 1])});
		}

		for (auto [l, r, ind] : reqs) {
			if (l % 2 == shift) {
				int lg = l / 2, rg = r / 2;
				if (rg - lg < SQRT) {
					for (int j = lg; j < rg; ++j) {
						add_edge(edges[j].ff, edges[j].ss);
					}
					can_start[ind] = dsu_ok;
					while (szof(changes)) {
						*changes.back().ff = changes.back().ss;
						changes.pop_back();
					}
				} else {
					reqs_here[lg / SQRT].push_back({{lg, rg}, ind});
				}
			}
		}
		
		for (int i = 0; i < szof(reqs_here); ++i) {
			sort(reqs_here[i].begin(), reqs_here[i].end(), [&](auto& a, auto& b) {
				return a.ff.ss < b.ff.ss;
			});
			int cut = (i + 1) * SQRT;
			int pos = cut;
			for (auto p : reqs_here[i]) {
				while (pos < p.ff.ss) {
					add_edge(edges[pos].ff, edges[pos].ss);
					++pos;
				}
				int mem = szof(changes);
				for (int j = cut - 1; j >= p.ff.ff; --j) {
					add_edge(edges[j].ff, edges[j].ss);
				}
				can_start[p.ss] = dsu_ok;
				while (szof(changes) > mem) {
					*changes.back().ff = changes.back().ss;
					changes.pop_back();
				}
			}
			while (szof(changes)) {
				*changes.back().ff = changes.back().ss;
				changes.pop_back();
			}
		}
	}

	// for (int i = 0; i < n; ++i) {
	// 	cerr << can_start[i];
	// }
	// cerr << endl;

	vector<ll> dp(n + 1);
	for (int i = 0; i < n; ++i) {
		dp[i]++;
		if (can_start[i]) {
			dp[i + arr[i] * 2 + 1] += dp[i];
		}
	}
	cout << accumulate(dp.begin(), dp.end(), 0ll) - n << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
